#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int cmp(const pair<int, int> &p1, const pair<int, int> &p2)
{
	if (p1.first == p2.first)
		return p1.second - p2.second;
	else
		return p1.second < p2.second;
}

void transform(pair<int, int> &p, int size)
{
	int tmp = p.first;
	p.first = size - p.second - 1;
	p.second = tmp;
}

int main()
{
	const int MAXSIZE = 1001;
	char line[MAXSIZE];
	vector<string> lines(MAXSIZE);

	//for (int i = 0; i < MAXSIZE; ++i)
		//lines[i].resize(MAXSIZE);

	int size;

	while (1)
	{
		scanf("%d\n", &size);
		if (!size)
			break;

		//vector<pair<int, int> > v;
		vector<int> v2;
		for (int i = 0; i < size; ++i)
		{
			scanf("%s\n", line);
			for (int j = 0; j < size; ++j)
				if (line[j] == 'O')
				{
					//pair<int, int> p = make_pair(j, i);
					//v.push_back(make_pair(j, i));
					//v.push_back(p);
					v2.push_back(i * size + j);
				}
		}

		for (int i = 0; i < size; ++i)
		{
			scanf("%s\n", line);
			lines[i] = string(line);
		}


		for (int i = 0; i < 4; ++i)
		{
			//sort(v.begin(), v.end(), cmp);
			sort(v2.begin(), v2.end());
			/*for (unsigned j = 0; j < v.size(); ++j)
			{
				printf("%c", lines[ v[j].first ][ v[j].second ]);
				//int tmp = v[j].first;
				//v[j].first = size - v[j].second - 1;
				//v[j].second = tmp;
				transform(v[j], size);
			}*/
			vector<int> vcopy(v2.size());
			for (unsigned j = 0; j < v2.size(); ++j)
			{
				int y = v2[j] / size;
				int x = v2[j] % size;
				printf("%c", lines[ y ][ x ]);
				int tmp = x;
				int x2 = size - y - 1;
				int y2 = x;
				vcopy[j] = x2 + size * y2;
				//v2[j] = x2 + size * y2;
				//v[i].first = size - v[i].second - 1;
				//v[i].second = tmp;
				//transform(v[i], size);
			}

			v2 = vcopy;
		}
		//v.clear();
		printf("\n");
	}

	printf("END\n");

	return 0;
}

